#! /usr/local/bin/perl

#############################################################################
# 
#############################################################################
#  
#   GLOBAL VARIABLES {
#
#############################################################################
$table="#cc9900";

#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################
# Set up the debuging flag.
&PrintHeader;

&readData;
#&dumpData;

&ReadEntry ;
&EXECUTE;
&writeData;
exit;


#############################################################################
#  
#   SUBROUTINES
#
#############################################################################
sub ReadEntry {             
   &ReadParse;     # Read arguments passed from fill-out form
   $command= ($in{'command'}) ? $in{'command'} : "emptyslots";
   $firstName= ($in{'firstName'}) ? $in{'firstName'} : "none";
   $lastName= ($in{'lastName'}) ? $in{'lastName'} : "none";
   $name = $firstName." ".$lastName;
   $day= ($in{'day'}) ? $in{'day'} : "eval(daynames[0])";
   $hours= ($in{'hours'}) ? $in{'hours'} : "noe";
   foreach $day (@days) {
       $selected{$day} = ($in{$day}) ? $in{$day} : "";
   }
   return;
}


#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
# Execution
#
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
sub EXECUTE {

    if ($command eq "Don`t Want"){
	&mark_preference("doesn`t want");
    }
    elsif ($command eq "Don`t Prefer"){
	&mark_preference("doesn`t prefer");
    }
    elsif ($command eq "Don`t Care" ){
	&unmark_preference;
    }   
    elsif ($command eq "Do Want"){
	&mark_preference("wants");
    }
    &viewSlots("");
    print "<h4>$command ";
    }
#
##############################################################################
#  
#
##############################################################################

#
sub readData {
    $index=0;
    $numofdays=0;
    open(IN, "caa_slots.db"); 
    while ( ($line=<IN>) ){
	chop($line);
	@fields = split ( /\|/, $line );
	if ($fields[0] eq "slots-begin") {
	    $n=0;
	    while (($line=<IN>) && !($line =~ /^slots-end/ ) ){
		chop($line);
		$slots[$n]=$line;
		$n++;
		#print ". $line\n";
	    }
	}
	elsif ($fields[0] eq "days-begin") {
	    $n=0;
	    while (($line=<IN>) && !($line =~ /^days-end/ ) ){
		chop($line);
		$days[$n]=$line;
		$n++;
		#print ". $line\n";
	    }
	}
	elsif ($line ne "") {
	    
	    $status=$fields[1];
	    $dh =$fields[0];
	    
	    $data{$dh}= $status;
	    #print " $dh|$status|$names\n";
	    #print "$line \n";
	    $n++;	
	}

    }
    close(IN);

}
sub writeData {
    open(OUT, ">caa_slots.db"); 
    print OUT  "days-begin\n";
    foreach $day (@days) {
	print OUT "$day\n";
    }
    print OUT  "days-end\n\n";
    print OUT  "slots-begin\n";
    foreach $slot (@slots) {
	print OUT  "$slot\n";
    }
    print OUT  "slots-end\n";
    print OUT "\n";



    foreach $mark (keys (%data)) {
	$current=$data{$mark};
	if ( $current ne "")
	   { print OUT "$mark|$data{$mark}\n"; }
    }

  close(OUT);


}

sub dumpData {

#     foreach $line (@data) {
# 	@fields = split ( /\|/, $line );
# 	$status=$fields[1];
# 	$h=$fields[2];
# 	$names=$fields[3];
# 	print "$status|$h|$names\n";
#      }

    foreach $key (keys %data) {
	print "$key|$data{$key}\n";
    }

#     for ($d=0;$d<$numofdays;$d++){
# 	$day=$days[$d];
# 	print "day|$day\n";
	
# 	$l=$data[$d][0];
# 	for ($i=1;$l ne "";$i++){
# 	    print "$l\n";
# 	    $l=$data[$d][$i];
# 	}
#     }
}
sub viewSlots {

    print  <<EOF;
<HTML>
<body  bgcolor=#007a00 link=black vlink=black>
<font face="Helvetica" color=yellow>


<CENTER>
<H1> Please Mark Time Slots First!!! </H1>
</CENTER>

<FORM name=SLOT METHOD="get" ACTION="https://osprey7.npac.syr.edu:5557/DB/other/caa.cgi"  >


<P>
<TABLE><TR>

EOF
    foreach $day (@days) {
	
	print "<td align=center><font face=\"Helvetica\" color=yellow><b> -$day- </b></font></td>";
    }

print  <<EOF;
</tr>
<TR>

EOF

    foreach $day (@days) {
print  <<EOF;
<td align=center><font face=\"Helvetica\" color=yellow><b>
<SELECT NAME="$day" multiple  size=8> 
EOF
	 foreach $slot (@slots) {
	     print "<option>$slot";
	 }
	print  <<EOF;
</SELECT>
</b></font></td>
EOF
}


print  <<EOF;


</tr></table>

<b>
First Name: <INPUT TYPE="TEXT" NAME="firstName" value="$firstName">
Last  Name: <INPUT TYPE="TEXT" NAME="lastName" value="$lastName"><BR>
</b>



<table bgcolor="#33ccff" pink width=100% ><tr> <td bgcolor="#33ccff" pink >
<b>
Mark above slots as I 
<font color=red>
<INPUT TYPE="SUBMIT" NAME="command" value="Don`t Want" ></font>, or
<font color=yellow>
<INPUT TYPE="SUBMIT" NAME="command" value="Don`t Prefer" ></font>, or 
<INPUT TYPE="SUBMIT" NAME="command" value="Don`t Care" >, or
<font color="green">
<INPUT TYPE="SUBMIT" NAME="command" value="Do Want" ></font>

</b>
</td></tr></table>

</FORM>

<h1>CURRENT STATUS: Click on time slots to see people marked.</h1>

<TABLE><TR>

EOF

    foreach $day (@days) {
	
	print "<td align=center><font face=\"Helvetica\" color=yellow><b> -$day- </b></font></td>";
    }


print  <<EOF;
</tr>
<TR>

EOF
 foreach $slot (@slots) {
     print "<tr>";
    foreach $day (@days) {
	$status=$data{$day.$slot};
	if ($status =~ /doesn`t want/)
	{$color="red";}
	elsif ($status =~ /doesn`t prefer/)
	{$color="yellow";}
	elsif($status =~ /wants/)
	{$color="#00ff00";}
	elsif($status =~ /doesn`t care/)
	{$color=$table; }
	else {$color=$table; }
	print "<td align=center bgcolor=$color><font face=\"Helvetica\" color=yellow><b>";
	print "<a href=\"JavaScript:onClick=alert(\'$status\');\">$slot</a></b></font></td>";
    }
	print "</tr>";

}

    




print  <<EOF;

</tr></table>


</BODY>
</HTML>



EOF

}

#
##############################################################################

sub replace {
    local($set,$nm,$option)=@_;
    @fields=split ( /;/, $set );
    $new="";
    foreach $val (@fields) {
	if ( $val =~ /$nm/ )
	    {$new.=$name." ".$option."; "; }
	elsif ($val ne" ") { $new.=$val."; ";}
    }
    return $new;
}
sub remove {
    local($set,$nm)=@_;
    @fields=split ( /;/, $set );
    $new="";
    foreach $val (@fields) {
# 	if (! $val =~ /\b\s\b/ ) {
# 	    print "<h1>***$val^^^";
# 	}
#	else {print "<h1>%%%";}
	if ( $val =~ /$nm/ )
	    {; }
	elsif ( $val ne " " ) { $new.=$val."; ";}
    }
    return $new;
}
	    
#
##############################################################################
#  
#
##############################################################################
#
sub  mark_preference { 
    local ($mark)=@_;
  
    foreach $selected_day (keys(%selected)) {
	@hours= split ( /~/, $selected{$selected_day} );
	
	foreach $h (@hours) {
	    if ($data{$selected_day.$h} =~ /$name/ ) {
		$data{$selected_day.$h}=replace($data{$selected_day.$h},$name,$mark);
	    } 
	    else {
		$data{$selected_day.$h} .= $name." $mark; "; 
	    }
	}
    }
}
sub  unmark_preference { 
    foreach $selected_day (keys(%selected)) {
	@hours= split ( /~/, $selected{$selected_day} );
	foreach $h (@hours) {
	    if ($data{$selected_day.$h} =~ /$name/ ) {
		$data{$selected_day.$h}=remove($data{$selected_day.$h},$name);
	    } 
	}
    }
}


#
##############################################################################
#  
#
##############################################################################
#

#
##############################################################################
#  
#
##############################################################################
#

##############################################################################
# 
#
##############################################################################

##############################################################################
#  scanFile: process each file in the directory
#
##############################################################################
sub scanFile {
    local($fn)=@_;
    open(IN, "$fn"); 
    $verified=1;
    while ( ($line=<IN>) && ($verified !=0)) {
	chop($line);
        @fields = split ( /\|/, $line );
        if(($fields[$ROOM] == $room) && 
	   !( ($fields[$FROMDATE] > $toDate) || ($fields[$TODATE] < $fromDate)) &&
	   !( ($fields[$FROMTIME] >= $toTime) || ($fields[$TOTIME] <= $fromTime)) ) {
	    $verified=0; 
	}
    }
    close(IN);
}


#
##############################################################################
#
# Results
#
##############################################################################

# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";

}


##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
  } else 
  {  # can be used for debugging on command line
      $in = <STDIN>;
      print "$in\n";
  }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '~' if (defined($in{$key})); # \~ is the multiple separator
      $in{$key} .= $val;
   }
   return;
}
